#pragma once

#include <Windows.h>
#include <Vfw.h>
#include <tchar.h>

class WaveFileWriter;
class Logger;

/**
 * Wavef[^o
 */
class WaveExtractor
{
public:

	/**
	 * RXgN^
	 *
	 * @param logger K[
	 */
	WaveExtractor(const Logger* logger);

	/**
	 * fXgN^
	 */
	~WaveExtractor();

	/**
	 * t@CJ
	 *
	 * @param filepath t@CpX
	 *
	 * @return ItrueԂ
	 */
	bool open(const TCHAR* filepath);

	/**
	 * t@C
	 */
	void close();

	/**
	 * o
	 *
	 * @param stream Ώۂ̃Xg[f[^nh
	 * @param outputFilePath o̓t@CpX NULL̏ꍇWo͂
	 *
	 * @return ItrueԂ
	 */
	bool extract(int streamNumber, const TCHAR* outputFilePath);

private:

	/**
	 * ǂݏXbhŋLf[^
	 */
	class SharedData
	{
	public:

		// G[tO
		bool error;

		// WAVEt@Co
		WaveFileWriter* writer;

		// obt@ ̃obt@𕡐ubNɕĎgp
		BYTE* buffer;

		// obt@ (2̗ݏ̒l)
		size_t bufferLength;

		// AVSt@C̓ǂݍ݃J[\(P: Byte)
		size_t readCursor;

		// ǂݍ݃XbhpCxg
		HANDLE readEvent;

		// oXbhpCxg
		HANDLE writeEvent;

		// K[
		const Logger* logger;

		/**
		 * RXgN^
		 *
		 * @param format WAVEt@C̃tH[}bg
		 * @param sampleSize WAVEf[^1TṽTCY
		 * @param length WAVEg`f[^̃TCY
		 * @param log K[
		 */
		SharedData(WAVEFORMATEX format, size_t sampleSize, size_t length, const Logger* log);

		/**
		 * fXgN^
		 */
		~SharedData();

		/**
		 * 
		 */
		bool initialize(const TCHAR* outputFilePath);
	};

	// t@Cnh
	PAVIFILE file_;

	// K[
	const Logger* logger_;

	/*
	 * WaveopXbh
	 *
	 * CXbhŃf[^̓ǂݍ݂s̃Xbhŏos
	 */
	static unsigned int __stdcall waveWriteThread(void* param);

	/*
	 * op
	 *
	 * @param stream Ώۂ̃Xg[f[^nh
	 * @param outputFilePath o̓t@CpX NULL̏ꍇWo͂
	 *
	 * @return ItrueԂ
	 */
	bool extractImpl(PAVISTREAM stream, const TCHAR* outputFilePath);
};